#include <bits/stdc++.h>
#define int long long
using namespace std;
int n,k,a[1048576],dp[2048][2048];
signed main()
{
ios_base::sync_with_stdio(false);
cin.tie(0);
cout.tie(0);
cin>>n>>k;
for(int i=1;i<=n;i++)cin>>a[i];
dp[1][1]=a[1];
for(int i=2;i<=n;i++)
{
    int p=0;
    for(int j=i;j>0;j--)p=p|a[j];
    dp[i][1]=p;
    for(int j=2;j<=min(i,k);j++)
    {
        int p=a[i];
        for(int i1=i-1;i1>0;i1--)
        {
            dp[i][j]=max(dp[i][j],dp[i1][j-1]&p);
            p=p|a[i1];
        }
    }
}
cout<<dp[n][k]<<endl;
return 0;
}
